## nm-initrd-generator nm-initrd-generator — early boot NetworkManager configuration generator |

## Synopsis

`nm-initrd-generator` [`OPTIONS`...] -- [`CMDLINE`...]

## Description

nm-initrd-generator scans the command line for options relevant to network configuration and creates configuration files for an early instance of NetworkManager run from the initial ramdisk during early boot.

## Options

`-c` | `--connections-dir` `path` | Output connection directory.
`-i` | `--initrd-data-dir` `path` | Output directory for initrd data (e.g. hostname).
`-d` | `--sysfs-dir` `path` | The sysfs mount point.
`-s` | `--stdout` | Dump connections to standard output. Useful for debugging.
`CMDLINE` | The options that appear on the kernel command line. The following options are recognized:
`ip`
`rd.route`
`bridge`
`bond`
`team`
`vlan`
`bootdev`
`nameserver`
`rd.peerdns`
`rd.bootif`
`rd.net.timeout.dhcp`
`BOOTIF`
Please consult the dracut.cmdline(7) manual for the documentation of the precise format of the values supported.

## Differences from the network-legacy dracut module

nm-initrd-generator generates a set of connections that are then configured by the NetworkManager instance running in the initrd. There are some differences in behavior compared to the network-legacy dracut module:

- When an interface is configured with a static address and a gateway, the network-legacy module waits that the gateway responds to arping requests before proceeding, while NetworkManager doesn't.

- network-legacy configures interfaces one by one in the order in which they are announced by udev. If multiple interfaces specify a hostname (from command line or from DHCP), the one from the last interface activated wins. With NetworkManager, hostnames from command line have higher precedence over ones from DHCP, and the last that appears in the command line wins.

## Exit Status

nm-initrd-generator exits with status 0. It ignores unrecognized options and prints an error message if it encounters a malformed option.

## See Also

dracut.cmdline(7), NetworkManager(8).